import { Jsonable } from './jsonable';
import { Payment } from './payment';
import { Request } from './request';
export declare class InternalData extends Jsonable {
    senderApiVersion: string;
    senderPackageName: string;
    additionalData: {
        [name: string]: string;
    };
    static fromJson(json: string): InternalData;
}
export declare class AppMessage extends Jsonable {
    messageType: string;
    messageData: string;
    responseMechanism: string;
    internalData: string;
    static from(messageType: string, messageData: string, internalData: InternalData, responseMechanism?: string): AppMessage;
    /**
       * Convert a JSON string into an {@link AppMessage} object if possible
       *
       * @param json The JSON to convert
       *
       * @returns A AppMessage object
       */
    static fromJson(json: string): AppMessage;
    static wrapPayment(payment: Payment, responseMechanism: string): AppMessage;
    static wrapRequest(request: Request, responseMechanism: string): AppMessage;
    static getVersion(): string;
    private static getInternalData;
}
