"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var InternalData_1, AppMessage_1;
Object.defineProperty(exports, "__esModule", { value: true });
const json2typescript_1 = require("json2typescript");
const jsonable_1 = require("./jsonable");
const constants_1 = require("./constants");
const additional_data_1 = require("./additional-data");
const request_1 = require("./request");
const API_COMPATIBILITY_VERSION = '2.1.2';
let InternalData = InternalData_1 = class InternalData extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.additionalData = {};
    }
    static fromJson(json) {
        return super.baseFromJson(json, InternalData_1);
    }
};
__decorate([
    json2typescript_1.JsonProperty('senderApiVersion', String),
    __metadata("design:type", String)
], InternalData.prototype, "senderApiVersion", void 0);
__decorate([
    json2typescript_1.JsonProperty('senderPackageName', String),
    __metadata("design:type", String)
], InternalData.prototype, "senderPackageName", void 0);
__decorate([
    json2typescript_1.JsonProperty('additionalData', Object),
    __metadata("design:type", Object)
], InternalData.prototype, "additionalData", void 0);
InternalData = InternalData_1 = __decorate([
    json2typescript_1.JsonObject('InternalData')
], InternalData);
exports.InternalData = InternalData;
let AppMessage = AppMessage_1 = class AppMessage extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.messageType = undefined; // See AppMessageTypes
        this.messageData = undefined; // The message data in JSON
        this.responseMechanism = undefined; // See ResponseMechanisms
        this.internalData = undefined; // Data that may be useful for internal use, such as API version, etc
    }
    static from(messageType, messageData, internalData, responseMechanism = constants_1.ResponseMechanisms.RESPONSE_SERVICE) {
        const appMess = new AppMessage_1();
        appMess.messageType = messageType;
        appMess.messageData = messageData;
        appMess.internalData = internalData.toJson();
        appMess.responseMechanism = responseMechanism;
        return appMess;
    }
    /**
       * Convert a JSON string into an {@link AppMessage} object if possible
       *
       * @param json The JSON to convert
       *
       * @returns A AppMessage object
       */
    static fromJson(json) {
        return super.baseFromJson(json, AppMessage_1);
    }
    static wrapPayment(payment, responseMechanism) {
        const paymentData = new additional_data_1.AdditionalData();
        paymentData.addData(constants_1.AppMessageTypes.PAYMENT_MESSAGE, payment);
        const request = request_1.Request.from(payment.flowType, paymentData);
        request.deviceId = payment.deviceId;
        const appMessage = AppMessage_1.from(constants_1.AppMessageTypes.PAYMENT_MESSAGE, request.toJson(), this.getInternalData(), responseMechanism);
        return appMessage;
    }
    static wrapRequest(request, responseMechanism) {
        return AppMessage_1.from(constants_1.AppMessageTypes.REQUEST_MESSAGE, request.toJson(), this.getInternalData(), responseMechanism);
    }
    static getVersion() {
        return API_COMPATIBILITY_VERSION;
    }
    static getInternalData() {
        const internalData = new InternalData();
        internalData.senderApiVersion = this.getVersion();
        internalData.senderPackageName = 'appflow-payment-initiation-api';
        return internalData;
    }
};
__decorate([
    json2typescript_1.JsonProperty('messageType', String),
    __metadata("design:type", String)
], AppMessage.prototype, "messageType", void 0);
__decorate([
    json2typescript_1.JsonProperty('messageData', String),
    __metadata("design:type", String)
], AppMessage.prototype, "messageData", void 0);
__decorate([
    json2typescript_1.JsonProperty('responseMechanism', String),
    __metadata("design:type", String)
], AppMessage.prototype, "responseMechanism", void 0);
__decorate([
    json2typescript_1.JsonProperty('internalData', String),
    __metadata("design:type", String)
], AppMessage.prototype, "internalData", void 0);
AppMessage = AppMessage_1 = __decorate([
    json2typescript_1.JsonObject('AppMessage')
], AppMessage);
exports.AppMessage = AppMessage;
