/**
 * A {@link BasketItemModifier} can be used to associate additional cost/amounts with a basket item, such as tax, discounts or add-ons.
 *
 * Either an absolute amount or a percentage must be set.
 */
export declare class BasketItemModifier {
    id: string;
    name: string;
    type: string;
    amount?: number;
    percentage?: number;
    /**
       * Create an instance of a modifier.
       *
       * Either an absolute amount or a percentage must be set.
       *
       * @param id         The id, if one exists. May be null
       * @param name       The name of the modifier.
       * @param type       The type of the modifier.
       * @param amount     The absolute amount of the modifier.
       * @param percentage The percentage applied to the item amounts.
       *
       * @returns The new BaskeTItemModifier instance
       */
    static from(name: string, type: string, amount?: number, percentage?: number, id?: string): BasketItemModifier;
}
