"use strict";
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ConfirmationInput_1;
Object.defineProperty(exports, "__esModule", { value: true });
const json2typescript_1 = require("json2typescript");
const jsonable_1 = require("../jsonable");
let ConfirmationInput = ConfirmationInput_1 = class ConfirmationInput extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.valueType = undefined;
        this.maxValueLength = -1;
        this.minValueLength = -1;
        this.valueRegEx = undefined;
    }
    /**
       * Convert a JSON string into an {@link ConfirmationInput} object if possible
       *
       * @param json The JSON to convert
       */
    static fromJson(json) {
        return jsonable_1.Jsonable.baseFromJson(json, ConfirmationInput_1);
    }
};
__decorate([
    json2typescript_1.JsonProperty('valueType'),
    __metadata("design:type", String)
], ConfirmationInput.prototype, "valueType", void 0);
__decorate([
    json2typescript_1.JsonProperty('maxValueLength'),
    __metadata("design:type", Number)
], ConfirmationInput.prototype, "maxValueLength", void 0);
__decorate([
    json2typescript_1.JsonProperty('minValueLength'),
    __metadata("design:type", Number)
], ConfirmationInput.prototype, "minValueLength", void 0);
__decorate([
    json2typescript_1.JsonProperty('valueRegEx', String, true),
    __metadata("design:type", String)
], ConfirmationInput.prototype, "valueRegEx", void 0);
ConfirmationInput = ConfirmationInput_1 = __decorate([
    json2typescript_1.JsonObject('ConfirmationInput')
], ConfirmationInput);
exports.ConfirmationInput = ConfirmationInput;
