"use strict";
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ConfirmationRequest_1;
Object.defineProperty(exports, "__esModule", { value: true });
const json2typescript_1 = require("json2typescript");
const jsonable_1 = require("../jsonable");
const confirmation_option_1 = require("./confirmation-option");
const confirmation_input_1 = require("./confirmation-input");
let ConfirmationRequest = ConfirmationRequest_1 = class ConfirmationRequest extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.id = undefined;
        this.type = undefined;
        this.titleText = undefined;
        this.description = undefined;
        this.confirmationOptions = undefined;
        this.multiSelect = false;
        this.confirmationInput = undefined;
    }
    /**
       * Convert a JSON string into an {@link ConfirmationRequest} object if possible
       *
       * @param json The JSON to convert
       */
    static fromJson(json) {
        return jsonable_1.Jsonable.baseFromJson(json, ConfirmationRequest_1);
    }
};
__decorate([
    json2typescript_1.JsonProperty('id'),
    __metadata("design:type", String)
], ConfirmationRequest.prototype, "id", void 0);
__decorate([
    json2typescript_1.JsonProperty('type'),
    __metadata("design:type", String)
], ConfirmationRequest.prototype, "type", void 0);
__decorate([
    json2typescript_1.JsonProperty('titleText', String, true),
    __metadata("design:type", String)
], ConfirmationRequest.prototype, "titleText", void 0);
__decorate([
    json2typescript_1.JsonProperty('description', String, true),
    __metadata("design:type", String)
], ConfirmationRequest.prototype, "description", void 0);
__decorate([
    json2typescript_1.JsonProperty('confirmationOptions', [confirmation_option_1.ConfirmationOption], true),
    __metadata("design:type", String)
], ConfirmationRequest.prototype, "confirmationOptions", void 0);
__decorate([
    json2typescript_1.JsonProperty('multiSelect'),
    __metadata("design:type", Boolean)
], ConfirmationRequest.prototype, "multiSelect", void 0);
__decorate([
    json2typescript_1.JsonProperty('confirmationInput'),
    __metadata("design:type", confirmation_input_1.ConfirmationInput)
], ConfirmationRequest.prototype, "confirmationInput", void 0);
ConfirmationRequest = ConfirmationRequest_1 = __decorate([
    json2typescript_1.JsonObject('ConfirmationRequest')
], ConfirmationRequest);
exports.ConfirmationRequest = ConfirmationRequest;
