"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var FlowEvent_1;
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const additional_data_1 = require("./additional-data");
const jsonable_1 = require("./jsonable");
/**
 * Represents an event in the flow.
 */
let FlowEvent = FlowEvent_1 = class FlowEvent extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.type = undefined;
        this.data = new additional_data_1.AdditionalData();
        this.eventTrigger = undefined;
        this.originatingRequestId = undefined;
        this.source = undefined;
        this.deviceId = undefined;
    }
    static from(type, eventTrigger, data = new additional_data_1.AdditionalData()) {
        const flowEvent = new FlowEvent_1();
        flowEvent.type = type;
        flowEvent.eventTrigger = eventTrigger;
        flowEvent.data = data;
        return flowEvent;
    }
    static fromJson(json) {
        return this.baseFromJson(json, FlowEvent_1);
    }
};
__decorate([
    json2typescript_1.JsonProperty('type'),
    __metadata("design:type", String)
], FlowEvent.prototype, "type", void 0);
__decorate([
    json2typescript_1.JsonProperty('data', additional_data_1.AdditionalData, true),
    __metadata("design:type", additional_data_1.AdditionalData)
], FlowEvent.prototype, "data", void 0);
__decorate([
    json2typescript_1.JsonProperty('eventTrigger', String, true),
    __metadata("design:type", String)
], FlowEvent.prototype, "eventTrigger", void 0);
__decorate([
    json2typescript_1.JsonProperty('originatingRequestId', String, true),
    __metadata("design:type", String)
], FlowEvent.prototype, "originatingRequestId", void 0);
__decorate([
    json2typescript_1.JsonProperty('source', String, true),
    __metadata("design:type", String)
], FlowEvent.prototype, "source", void 0);
__decorate([
    json2typescript_1.JsonProperty('deviceId', String, true),
    __metadata("design:type", String)
], FlowEvent.prototype, "deviceId", void 0);
FlowEvent = FlowEvent_1 = __decorate([
    json2typescript_1.JsonObject('FlowEvent')
], FlowEvent);
exports.FlowEvent = FlowEvent;
