/**
 * Represents a measurement with a value and unit.
 *
 * Examples are "2.5 kilograms" or "13.45 feet".
 */
export declare class Measurement {
    value: number;
    unit: string;
    /**
       * Create and return a measuremnet object from the values given
       *
       * @param value The amount the measurement represents (can be a float if required)
       * @param unit The unit of measurement e.g g, kg, m, cm, mm
       *
       * @returns The newly created measurement object
       */
    static from(value: number, unit: string): Measurement;
}
