import { Amounts } from './amounts';
import { Basket } from './basket';
import { Customer } from './customer';
import { Token } from './token';
import { AdditionalData } from './additional-data';
import { Jsonable } from './jsonable';
export declare enum FlowTypes {
    sale = "sale",
    refund = "refund",
    motoSale = "motoSale",
    motoRefund = "motoRefund",
    preAuthorisation = "preAuthorisation",
    preAuthCompletion = "preAuthCompletion",
    deposit = "deposit",
    reversal = "reversal",
    tokenisation = "tokenisation",
    batchClosure = "batchClosure",
    receiptDelivery = "receiptDelivery"
}
/**
 * Payment model containing relevant information for initiating payments involving amounts.
 *
 * For other type of requests (such as reversals), please see {@link Request}
 */
export declare class Payment extends Jsonable {
    id: string;
    flowType: string;
    flowName?: string;
    amounts: Amounts;
    paymentMethod?: string;
    basket?: Basket;
    customer?: Customer;
    splitEnabled: boolean;
    cardToken?: Token;
    additionalData: AdditionalData;
    isExternalId: boolean;
    source?: string;
    deviceId?: string;
    constructor();
    /**
       * Convert a JSON string into an {@link Payment} object if possible
       *
       * @param json The JSON to convert
       *
       * @returns A Payment object
       */
    static fromJson(json: string): Payment;
}
