import { Jsonable } from './jsonable';
import { Request } from './request';
import { AdditionalData } from './additional-data';
/**
 * Response to a generic {@link Request} that contains the outcome and bespoke response data for that request type.
 *
 * @tsoaModel
 */
export declare class Response extends Jsonable {
    originatingRequest: Request;
    success: boolean;
    outcomeMessage: string;
    responseData: AdditionalData;
    flowServiceId?: string;
    processedInBackground: boolean;
    /**
       * Convert a JSON string into a {@link Response} object if possible
       *
       * @param json The JSON to convert
       */
    static fromJson(json: string): Response;
}
