import { AdditionalData } from './additional-data';
import { Amounts } from './amounts';
import { Card } from './card';
export declare enum TransactionResponseOutcome {
    APPROVED = "APPROVED",
    DECLINED = "DECLINED"
}
/**
 * A transaction response representing the outcome of processing a {@link TransactionRequest}.
 */
export declare class TransactionResponse {
    id: string;
    card?: Card;
    outcome: TransactionResponseOutcome;
    outcomeMessage: string;
    amounts?: Amounts;
    responseCode?: string;
    paymentMethod: string;
    references: AdditionalData;
    flowServiceId?: string;
    flowStage?: string;
}
