"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
class PreConditions {
    PreConditions() {
    }
    static checkState(check, message) {
        if (!check) {
            throw new InvalidArgumentError(message);
        }
    }
    static checkArgument(check, message) {
        if (!check) {
            throw new InvalidArgumentError(message);
        }
    }
    static checkNotNull(object, message) {
        if (object == null) {
            throw new InvalidArgumentError(message);
        }
    }
    static checkStringNotEmpty(str, message) {
        if (str == null || str === '') {
            throw new InvalidArgumentError(message);
        }
    }
    static checkNotEmpty(array, message) {
        if (array == null || array.length === 0) {
            throw new InvalidArgumentError(message);
        }
    }
    static checkNotNegative(number, message) {
        if (number < 0) {
            throw new InvalidArgumentError(message);
        }
    }
}
exports.PreConditions = PreConditions;
class InvalidArgumentError extends Error {
    constructor(message) {
        super(message);
        Object.setPrototypeOf(this, new.target.prototype);
        this.name = InvalidArgumentError.name;
    }
}
exports.InvalidArgumentError = InvalidArgumentError;
