import { Jsonable } from './jsonable';
/**
 * Amount represented by a value in its subunit form (such as cents or pence) and currency (ISO 4217).
 */
export declare class Amount extends Jsonable {
    value: number;
    currency: string;
    /**
       * Convert a JSON string into an {@link Amount} object if possible
       *
       * @param json The JSON to convert
       */
    fromJson(json: string): Amount;
    /**
       * Create a new Amount instance.
       *
       * @param value    The value in subunit form (cents, pence, etc)
       * @param currency The ISO-4217 currency code
       *
       * @returns The initialised amount object
       */
    static from(value: number, currency: string): Amount;
}
