"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Amount_1;
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const jsonable_1 = require("./jsonable");
/**
 * Amount represented by a value in its subunit form (such as cents or pence) and currency (ISO 4217).
 */
let Amount = Amount_1 = class Amount extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.value = 0;
        this.currency = 'XXX';
    }
    /**
       * Convert a JSON string into an {@link Amount} object if possible
       *
       * @param json The JSON to convert
       */
    fromJson(json) {
        return jsonable_1.Jsonable.baseFromJson(json, Amount_1);
    }
    /**
       * Create a new Amount instance.
       *
       * @param value    The value in subunit form (cents, pence, etc)
       * @param currency The ISO-4217 currency code
       *
       * @returns The initialised amount object
       */
    static from(value, currency) {
        const a = new Amount_1();
        a.value = value;
        a.currency = currency;
        return a;
    }
};
__decorate([
    json2typescript_1.JsonProperty('value'),
    __metadata("design:type", Number)
], Amount.prototype, "value", void 0);
__decorate([
    json2typescript_1.JsonProperty('currency'),
    __metadata("design:type", String)
], Amount.prototype, "currency", void 0);
Amount = Amount_1 = __decorate([
    json2typescript_1.JsonObject('Amount')
], Amount);
exports.Amount = Amount;
