"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const app_message_1 = require("./app-message");
describe('AppMessage', () => {
    it('should create an instance', () => {
        expect(new app_message_1.AppMessage()).toBeTruthy();
    });
    it('should serialise and deserialise correctly', () => {
        const internalData = new app_message_1.InternalData();
        internalData.senderApiVersion = '5.6.7';
        internalData.senderPackageName = 'com.me';
        internalData.additionalData.banana = 'ripe';
        const appMessage = app_message_1.AppMessage.from('blargh', 'bloop', internalData);
        const json = appMessage.toJson();
        console.log(json);
        const result = app_message_1.AppMessage.fromJson(json);
        expect(result.messageType).toBe('blargh');
        expect(result.messageData).toBe('bloop');
        expect(result.internalData).toBeTruthy();
        const intData = app_message_1.InternalData.fromJson(result.internalData);
        console.log(intData);
        expect(intData.additionalData.banana).toBe('ripe');
    });
});
