import { Jsonable } from "./jsonable";
export declare enum CloudFlowMessageTypes {
    REQUEST_MESSAGE = "request",
    PAYMENT_MESSAGE = "payment",
    RESPONSE_MESSAGE = "response",
    PAYMENT_RESPONSE_MESSAGE = "paymentResponse",
    FLOW_EVENT_MESSAGE = "flowEvent",
    FLOW_EXCEPTION_MESSAGE = "flowException",
    ERROR_MESSAGE = "error"
}
export declare class CloudFlowMessage extends Jsonable {
    source: string;
    target: string;
    format: string;
    type: string;
    version: string;
    requestId: string;
    originatingRequestId: string;
    payload: any;
    constructor();
    /**
     * Convert a JSON string into an {@link CloudFlowMessage} object if possible
     *
     * @param json The JSON to convert
     *
     * @returns A CloudFlowMessage object
     */
    static fromJson(json: string): CloudFlowMessage;
}
