"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var CloudFlowMessage_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudFlowMessage = exports.CloudFlowMessageTypes = void 0;
const json2typescript_1 = require("json2typescript");
const jsonable_1 = require("./jsonable");
const payment_1 = require("./payment");
const payment_response_1 = require("./payment-response");
const request_1 = require("./request");
const response_1 = require("./response");
const flow_event_1 = require("./flow-event");
const flow_exception_1 = require("./flow-exception");
var CloudFlowMessageTypes;
(function (CloudFlowMessageTypes) {
    // Initiating messages
    CloudFlowMessageTypes["REQUEST_MESSAGE"] = "request";
    CloudFlowMessageTypes["PAYMENT_MESSAGE"] = "payment";
    // Other messages
    CloudFlowMessageTypes["RESPONSE_MESSAGE"] = "response";
    CloudFlowMessageTypes["PAYMENT_RESPONSE_MESSAGE"] = "paymentResponse";
    CloudFlowMessageTypes["FLOW_EVENT_MESSAGE"] = "flowEvent";
    CloudFlowMessageTypes["FLOW_EXCEPTION_MESSAGE"] = "flowException";
    CloudFlowMessageTypes["ERROR_MESSAGE"] = "error";
})(CloudFlowMessageTypes = exports.CloudFlowMessageTypes || (exports.CloudFlowMessageTypes = {}));
let CloudFlowMessage = CloudFlowMessage_1 = class CloudFlowMessage extends jsonable_1.Jsonable {
    constructor() {
        super();
        this.source = undefined;
        this.target = undefined;
        this.format = "appflow";
        this.type = undefined;
        this.version = undefined;
        this.requestId = undefined;
        this.originatingRequestId = undefined;
        this.payload = undefined;
    }
    /**
     * Convert a JSON string into an {@link CloudFlowMessage} object if possible
     *
     * @param json The JSON to convert
     *
     * @returns A CloudFlowMessage object
     */
    static fromJson(json) {
        return super.baseFromJson(json, CloudFlowMessage_1);
    }
};
__decorate([
    json2typescript_1.JsonProperty("source", String, true),
    __metadata("design:type", String)
], CloudFlowMessage.prototype, "source", void 0);
__decorate([
    json2typescript_1.JsonProperty("target", String, true),
    __metadata("design:type", String)
], CloudFlowMessage.prototype, "target", void 0);
__decorate([
    json2typescript_1.JsonProperty("format", String),
    __metadata("design:type", String)
], CloudFlowMessage.prototype, "format", void 0);
__decorate([
    json2typescript_1.JsonProperty("type", String),
    __metadata("design:type", String)
], CloudFlowMessage.prototype, "type", void 0);
__decorate([
    json2typescript_1.JsonProperty("version", String),
    __metadata("design:type", String)
], CloudFlowMessage.prototype, "version", void 0);
__decorate([
    json2typescript_1.JsonProperty("requestId", String, true),
    __metadata("design:type", String)
], CloudFlowMessage.prototype, "requestId", void 0);
__decorate([
    json2typescript_1.JsonProperty("originatingRequestId", String, true),
    __metadata("design:type", String)
], CloudFlowMessage.prototype, "originatingRequestId", void 0);
__decorate([
    json2typescript_1.JsonProperty("payload", payment_1.Payment, payment_response_1.PaymentResponse, request_1.Request, response_1.Response, flow_exception_1.FlowException, flow_event_1.FlowEvent, true),
    __metadata("design:type", Object)
], CloudFlowMessage.prototype, "payload", void 0);
CloudFlowMessage = CloudFlowMessage_1 = __decorate([
    json2typescript_1.JsonObject,
    __metadata("design:paramtypes", [])
], CloudFlowMessage);
exports.CloudFlowMessage = CloudFlowMessage;
