"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cloud_flow_message_1 = require("./cloud-flow-message");
const payment_1 = require("./payment");
describe('CloudFlowMessage', () => {
    it('should create an instance', () => {
        expect(new cloud_flow_message_1.CloudFlowMessage()).toBeTruthy();
    });
    it('should serialise and deserialise correctly', () => {
        var cfm = new cloud_flow_message_1.CloudFlowMessage();
        cfm.source = "5675856";
        cfm.type = "cheese";
        cfm.target = "5675856";
        cfm.version = "5675856";
        cfm.originatingRequestId = "5675856";
        cfm.payload = new payment_1.Payment();
        var json = cfm.toJson();
        console.log(json);
        var result = cloud_flow_message_1.CloudFlowMessage.fromJson(json);
        expect(result.source).toBe("5675856");
        expect(result.target).toBe("5675856");
        expect(result.type).toBe("cheese");
        expect(result.version).toBe("5675856");
        expect(result.originatingRequestId).toBe("5675856");
        expect(result.payload).toBeTruthy();
    });
});
