import { FlowConfig } from './flow-config';
import { FlowApp } from './flow-app';
export declare enum AppExecutionType {
    SINGLE = "SINGLE",
    SINGLE_SELECT = "SINGLE_SELECT",
    DYNAMIC_SELECT = "DYNAMIC_SELECT",
    MULTIPLE = "MULTIPLE",
    NONE = "NONE"
}
export declare class FlowStage {
    name: string;
    appExecutionType: string;
    flowApps: Array<FlowApp>;
    innerFlow?: FlowConfig;
    static from(name: string, appExecutionType: AppExecutionType): FlowStage;
    /**
       * Check whether the stage has an inner flow.
       *
       * @return True if inner flow, false otherwise
       */
    hasInnerFlow(): boolean;
    /**
       * Utility method to get innerFlow as a genuine {@link FlowConfig} object
       *
       * This allows you to use methods on the {@link FlowConfig} returned as due to a json2typescript restriction
       * the object cannot be setup automatically when deserialising.
       *
       * @return The inner flow config if there is one
       */
    getInnerFlow(): FlowConfig;
}
