"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var FlowStage_1;
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
// eslint-disable-next-line import/no-cycle
const flow_config_1 = require("./flow-config");
const flow_app_1 = require("./flow-app");
var AppExecutionType;
(function (AppExecutionType) {
    AppExecutionType["SINGLE"] = "SINGLE";
    AppExecutionType["SINGLE_SELECT"] = "SINGLE_SELECT";
    AppExecutionType["DYNAMIC_SELECT"] = "DYNAMIC_SELECT";
    AppExecutionType["MULTIPLE"] = "MULTIPLE";
    AppExecutionType["NONE"] = "NONE";
})(AppExecutionType = exports.AppExecutionType || (exports.AppExecutionType = {}));
let FlowStage = FlowStage_1 = class FlowStage {
    constructor() {
        this.name = undefined;
        this.appExecutionType = AppExecutionType.NONE;
        this.flowApps = [];
        // FIXME - at this time json2typescript doesn't support circular models so this has to be a default object here instead of a FlowConfig as it should be
        this.innerFlow = undefined;
    }
    static from(name, appExecutionType) {
        const fs = new FlowStage_1();
        fs.name = name;
        fs.appExecutionType = appExecutionType;
        return fs;
    }
    /**
       * Check whether the stage has an inner flow.
       *
       * @return True if inner flow, false otherwise
       */
    hasInnerFlow() {
        return this.innerFlow !== undefined;
    }
    /**
       * Utility method to get innerFlow as a genuine {@link FlowConfig} object
       *
       * This allows you to use methods on the {@link FlowConfig} returned as due to a json2typescript restriction
       * the object cannot be setup automatically when deserialising.
       *
       * @return The inner flow config if there is one
       */
    getInnerFlow() {
        if (this.innerFlow) {
            return flow_config_1.FlowConfig.fromJson(JSON.stringify(this.innerFlow));
        }
        return null;
    }
};
__decorate([
    json2typescript_1.JsonProperty('name'),
    __metadata("design:type", String)
], FlowStage.prototype, "name", void 0);
__decorate([
    json2typescript_1.JsonProperty('appExecutionType'),
    __metadata("design:type", String)
], FlowStage.prototype, "appExecutionType", void 0);
__decorate([
    json2typescript_1.JsonProperty('flowApps', [flow_app_1.FlowApp]),
    __metadata("design:type", Array)
], FlowStage.prototype, "flowApps", void 0);
__decorate([
    json2typescript_1.JsonProperty('innerFlow', json2typescript_1.Any, true),
    __metadata("design:type", flow_config_1.FlowConfig)
], FlowStage.prototype, "innerFlow", void 0);
FlowStage = FlowStage_1 = __decorate([
    json2typescript_1.JsonObject('FlowStage')
], FlowStage);
exports.FlowStage = FlowStage;
