import { AdditionalData } from '../additional-data';
import { PaymentFlowServices } from '../payment-flow-services';
import { FlowConfigurations } from './flow-configurations';
import { FpsSettings } from './fps-settings';
import { AppFlowSettings } from './app-flow-settings';
export declare class PaymentSettings {
    flowConfigurations: FlowConfigurations;
    allServices: PaymentFlowServices;
    fpsSettings: FpsSettings;
    appFlowSettings: AppFlowSettings;
    additionalSettings: AdditionalData;
    /**
       * Get an instance of {@link PaymentFlowServices} that contains a filtered list of services based on the provided flow configuration.
       *
       * This can be used to ensure that you retrieve the correct set of supported currencies, payment methods, etc based on the flow that
       * will be processed.
       *
       * If no applications are defined in the flow config, it is assumed any is eligible and the full list of services will be returned.
       *
       * If there is no flow by the provided name, all services will be returned.
       *
       * @param flowName The name of the flow configuration to filter services by
       * @return An instance of {@link PaymentFlowServices} with filtered set of services, or null if no flow config found
       */
    getServicesForFlow(flowName: string): PaymentFlowServices;
    static fromJson(json: string): PaymentSettings;
}
