"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const customer_1 = require("./customer");
const additional_data_1 = require("./additional-data");
const token_1 = require("./token");
describe('Customer', () => {
    it('should create an instance', () => {
        expect(new customer_1.Customer()).toBeTruthy();
    });
    it('should serialize and deserialize correctly', () => {
        const ad = new additional_data_1.AdditionalData();
        ad.addData('cheese', 'bire');
        const token = token_1.Token.from('5353535', 'card');
        const tokens = new Array();
        tokens[0] = token;
        const customer = customer_1.Customer.from('123', 'Jonny Big Cheese', ad, tokens);
        const json = customer.toJson();
        const customerResult = customer_1.Customer.fromJson(json);
        expect(customerResult).toStrictEqual(customer);
    });
});
