import { AdditionalData } from './additional-data';
import { Jsonable } from './jsonable';
export declare enum DeviceDataKeys {
    MANUFACTURER = "maufacturer",
    MODEL = "model",
    SERIAL = "serial"
}
/**
 * Represents a device.
 */
export declare class Device extends Jsonable {
    referenceId: string;
    serialNumber: string;
    model: string;
    name?: string;
    location?: string;
    details: AdditionalData;
    /**
       * Creates and returns a new Device object based on the details given
       *
       * @param referenceId The unique Id of the device
       * @param name The friendly name of the device
       * @param details Any other details to be associated with this device e,g, make and model etc see {@link DeviceDataKeys}
       *
       * @returns The new Customer object
       */
    static from(referenceId: string, name: string, details?: AdditionalData): Device;
    /**
       * Convert a JSON string into an {@link Device} object if possible
       *
       * @param json The JSON to convert
       */
    static fromJson(json: string): Device;
}
