"use strict";
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var ConfirmationInputTypes;
(function (ConfirmationInputTypes) {
    ConfirmationInputTypes["CONFIRMATION_INPUT_TYPE_TEXT"] = "text";
    ConfirmationInputTypes["CONFIRMATION_INPUT_TYPE_NUMERIC"] = "numeric";
    ConfirmationInputTypes["CONFIRMATION_INPUT_TYPE_PHONE"] = "phone";
    ConfirmationInputTypes["CONFIRMATION_INPUT_TYPE_EMAIL"] = "email";
    ConfirmationInputTypes["CONFIRMATION_INPUT_TYPE_WEB"] = "web";
})(ConfirmationInputTypes = exports.ConfirmationInputTypes || (exports.ConfirmationInputTypes = {}));
var ConfirmationOptionValues;
(function (ConfirmationOptionValues) {
    ConfirmationOptionValues["CONFIRMATION_OPTION_APPROVE"] = "approve";
    ConfirmationOptionValues["CONFIRMATION_OPTION_REJECT"] = "reject";
    ConfirmationOptionValues["CONFIRMATION_OPTION_YES"] = "yes";
    ConfirmationOptionValues["CONFIRMATION_OPTION_NO"] = "no";
    ConfirmationOptionValues["CONFIRMATION_OPTION_OK"] = "ok";
    ConfirmationOptionValues["CONFIRMATION_OPTION_CANCEL"] = "cancel";
})(ConfirmationOptionValues = exports.ConfirmationOptionValues || (exports.ConfirmationOptionValues = {}));
var ConfirmationTypes;
(function (ConfirmationTypes) {
    ConfirmationTypes["CONFIRMATION_TYPE_CARD"] = "card";
    ConfirmationTypes["CONFIRMATION_TYPE_SIGNATURE"] = "signature";
})(ConfirmationTypes = exports.ConfirmationTypes || (exports.ConfirmationTypes = {}));
var FlowEventTypes;
(function (FlowEventTypes) {
    FlowEventTypes["EVENT_CONFIRMATION_REQUEST"] = "confirmationRequest";
    FlowEventTypes["EVENT_CONFIRMATION_RESPONSE"] = "confirmationResponse";
    FlowEventTypes["EVENT_FINAL_AMOUNT_REQUEST"] = "finalAmountRequest";
    FlowEventTypes["EVENT_FINAL_AMOUNT_RESPONSE"] = "finalAmountResponse";
    FlowEventTypes["EVENT_NOTIFY_ACTION"] = "notifyAction";
    FlowEventTypes["EVENT_PROGRESS_MESSAGE"] = "progressMessage";
    FlowEventTypes["EVENT_RECEIPT"] = "receipt";
})(FlowEventTypes = exports.FlowEventTypes || (exports.FlowEventTypes = {}));
var NotifyActionTypes;
(function (NotifyActionTypes) {
    NotifyActionTypes["ABORT"] = "abort";
    NotifyActionTypes["DUPLICATE_RECEIPT"] = "duplicateReceipt";
    NotifyActionTypes["EMV_RECEIPT_PRINT"] = "emvReceiptPrint";
    NotifyActionTypes["EFT_COMMUNICATION_FINISHED"] = "eftFinished";
    NotifyActionTypes["COMMUNICATION_FINISHED"] = "communicationFinished";
    NotifyActionTypes["COMMUNICATION_STARTED"] = "communicationStarted";
})(NotifyActionTypes = exports.NotifyActionTypes || (exports.NotifyActionTypes = {}));
