import { Jsonable } from './jsonable';
/**
 * An exception that will be returned to a client for fatal flow errors
 *
 * This exception will contain an errorCode that can be used to handle the error or display relevant information to the user.
 *
 * The errorMessage contained in the exception is a human readable message that should be used for debugging purposes only
 */
export declare class FlowException extends Jsonable {
    errorCode: string;
    errorMessage: string;
    static from(errorCode: string, errorMessage: string): FlowException;
    static fromJson(json: string): FlowException;
}
