"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var FlowException_1;
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const jsonable_1 = require("./jsonable");
/**
 * An exception that will be returned to a client for fatal flow errors
 *
 * This exception will contain an errorCode that can be used to handle the error or display relevant information to the user.
 *
 * The errorMessage contained in the exception is a human readable message that should be used for debugging purposes only
 */
let FlowException = FlowException_1 = class FlowException extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.errorCode = undefined;
        this.errorMessage = undefined;
    }
    static from(errorCode, errorMessage) {
        const fe = new FlowException_1();
        fe.errorCode = errorCode;
        fe.errorMessage = errorMessage;
        return fe;
    }
    static fromJson(json) {
        return this.baseFromJson(json, FlowException_1);
    }
};
__decorate([
    json2typescript_1.JsonProperty('errorCode', String),
    __metadata("design:type", String)
], FlowException.prototype, "errorCode", void 0);
__decorate([
    json2typescript_1.JsonProperty('errorMessage', String),
    __metadata("design:type", String)
], FlowException.prototype, "errorMessage", void 0);
FlowException = FlowException_1 = __decorate([
    json2typescript_1.JsonObject('FlowException')
], FlowException);
exports.FlowException = FlowException;
