"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const jsonConvert = new json2typescript_1.JsonConvert(json2typescript_1.OperationMode.ENABLE);
class Jsonable {
    toJson() {
        return JSON.stringify(jsonConvert.serialize(this));
    }
    static baseFromJson(json, classReference) {
        const deserialised = JSON.parse(json);
        return this.baseFromJsonObject(deserialised, classReference);
    }
    static baseFromJsonObject(jsonObj, classReference) {
        return jsonConvert.deserializeObject(jsonObj, classReference);
    }
}
exports.Jsonable = Jsonable;
