"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const additional_data_1 = require("./additional-data");
/**
 * Represents the capabilities of a flow service.
 */
let PaymentFlowServiceInfo = class PaymentFlowServiceInfo {
    constructor() {
        this.id = undefined;
        this.packageName = undefined;
        this.vendor = undefined;
        this.serviceVersion = undefined;
        this.apiVersion = undefined;
        this.displayName = undefined;
        this.hasAccessibilityMode = false;
        this.supportedFlowTypes = [];
        this.customRequestTypes = [];
        this.supportedDataKeys = [];
        this.additionalInfo = new additional_data_1.AdditionalData();
        this.stages = [];
        // @JsonProperty("flowAndStagesDefinitions")
        // flowAndStagesDefinitions: Map<string, string[]>;
        this.canAdjustAmounts = false;
        this.canPayAmounts = false;
        this.defaultCurrency = undefined;
        this.supportedCurrencies = [];
        this.paymentMethods = [];
    }
};
__decorate([
    json2typescript_1.JsonProperty('id'),
    __metadata("design:type", String)
], PaymentFlowServiceInfo.prototype, "id", void 0);
__decorate([
    json2typescript_1.JsonProperty('packageName'),
    __metadata("design:type", String)
], PaymentFlowServiceInfo.prototype, "packageName", void 0);
__decorate([
    json2typescript_1.JsonProperty('vendor'),
    __metadata("design:type", String)
], PaymentFlowServiceInfo.prototype, "vendor", void 0);
__decorate([
    json2typescript_1.JsonProperty('serviceVersion'),
    __metadata("design:type", String)
], PaymentFlowServiceInfo.prototype, "serviceVersion", void 0);
__decorate([
    json2typescript_1.JsonProperty('apiVersion'),
    __metadata("design:type", String)
], PaymentFlowServiceInfo.prototype, "apiVersion", void 0);
__decorate([
    json2typescript_1.JsonProperty('displayName'),
    __metadata("design:type", String)
], PaymentFlowServiceInfo.prototype, "displayName", void 0);
__decorate([
    json2typescript_1.JsonProperty('hasAccessibilityMode'),
    __metadata("design:type", Boolean)
], PaymentFlowServiceInfo.prototype, "hasAccessibilityMode", void 0);
__decorate([
    json2typescript_1.JsonProperty('supportedFlowTypes', [String]),
    __metadata("design:type", Array)
], PaymentFlowServiceInfo.prototype, "supportedFlowTypes", void 0);
__decorate([
    json2typescript_1.JsonProperty('customRequestTypes', [String]),
    __metadata("design:type", Array)
], PaymentFlowServiceInfo.prototype, "customRequestTypes", void 0);
__decorate([
    json2typescript_1.JsonProperty('supportedDataKeys', [String]),
    __metadata("design:type", Array)
], PaymentFlowServiceInfo.prototype, "supportedDataKeys", void 0);
__decorate([
    json2typescript_1.JsonProperty('additionalInfo', additional_data_1.AdditionalData),
    __metadata("design:type", additional_data_1.AdditionalData)
], PaymentFlowServiceInfo.prototype, "additionalInfo", void 0);
__decorate([
    json2typescript_1.JsonProperty('stages', [String]),
    __metadata("design:type", Array)
], PaymentFlowServiceInfo.prototype, "stages", void 0);
__decorate([
    json2typescript_1.JsonProperty('canAdjustAmounts'),
    __metadata("design:type", Boolean)
], PaymentFlowServiceInfo.prototype, "canAdjustAmounts", void 0);
__decorate([
    json2typescript_1.JsonProperty('canPayAmounts'),
    __metadata("design:type", Boolean)
], PaymentFlowServiceInfo.prototype, "canPayAmounts", void 0);
__decorate([
    json2typescript_1.JsonProperty('defaultCurrency'),
    __metadata("design:type", String)
], PaymentFlowServiceInfo.prototype, "defaultCurrency", void 0);
__decorate([
    json2typescript_1.JsonProperty('supportedCurrencies', [String]),
    __metadata("design:type", Array)
], PaymentFlowServiceInfo.prototype, "supportedCurrencies", void 0);
__decorate([
    json2typescript_1.JsonProperty('paymentMethods', [String]),
    __metadata("design:type", Array)
], PaymentFlowServiceInfo.prototype, "paymentMethods", void 0);
PaymentFlowServiceInfo = __decorate([
    json2typescript_1.JsonObject('PaymentFlowServiceInfo')
], PaymentFlowServiceInfo);
exports.PaymentFlowServiceInfo = PaymentFlowServiceInfo;
