import { PaymentFlowServiceInfo } from './payment-flow-service-info';
/**
 * Exposes payment and flow services information with helper methods to retrieve collated data across all services.
 */
export declare class PaymentFlowServices {
    paymentFlowServiceInfoList: Array<PaymentFlowServiceInfo>;
    supportedRequestTypes: Array<string>;
    supportedCurrencies: Array<string>;
    supportedPaymentMethods: Array<string>;
    supportedDataKeys: Array<string>;
    static from(paymentFlowServiceInfoList: Array<PaymentFlowServiceInfo>): PaymentFlowServices;
    private static union;
    /**
       * Get the flow service with the provided id.
       *
       * @param id The flow service id
       * @return An instance of PaymentFlowServiceInfo if a match was found, or null otherwise
       */
    getFlowServiceFromId(id: string): PaymentFlowServiceInfo;
}
