import { AdditionalData } from './additional-data';
import { Jsonable } from "./jsonable";
/**
 * Provides remote connection details for a device
 */
export declare class RemoteConnectionDetails extends Jsonable {
    connectionId: string;
    connectionType: string;
    connectionUrl: string;
    expiry: number;
    connectionParameters: AdditionalData;
    constructor();
    hasExpired(): boolean;
    /**
     * Convert a JSON string into an {@link RemoteConnectionDetails} object if possible
     *
     * @param json The JSON to convert
     */
    static fromJson(json: string): RemoteConnectionDetails;
}
