"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var RemoteConnectionDetails_1;
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const additional_data_1 = require("./additional-data");
const jsonable_1 = require("./jsonable");
const uuid_1 = require("uuid");
/**
 * Provides remote connection details for a device
 */
let RemoteConnectionDetails = RemoteConnectionDetails_1 = class RemoteConnectionDetails extends jsonable_1.Jsonable {
    constructor() {
        super();
        this.connectionId = undefined;
        this.connectionType = undefined;
        this.connectionUrl = undefined;
        this.expiry = 0;
        this.connectionParameters = new additional_data_1.AdditionalData();
        this.connectionId = uuid_1.v4();
    }
    hasExpired() {
        return this.expiry <= new Date().getTime();
    }
    /**
     * Convert a JSON string into an {@link RemoteConnectionDetails} object if possible
     *
     * @param json The JSON to convert
     */
    static fromJson(json) {
        return jsonable_1.Jsonable.baseFromJson(json, RemoteConnectionDetails_1);
    }
};
__decorate([
    json2typescript_1.JsonProperty("connectionId"),
    __metadata("design:type", String)
], RemoteConnectionDetails.prototype, "connectionId", void 0);
__decorate([
    json2typescript_1.JsonProperty("connectionType"),
    __metadata("design:type", String)
], RemoteConnectionDetails.prototype, "connectionType", void 0);
__decorate([
    json2typescript_1.JsonProperty("connectionUrl"),
    __metadata("design:type", String)
], RemoteConnectionDetails.prototype, "connectionUrl", void 0);
__decorate([
    json2typescript_1.JsonProperty("expiry"),
    __metadata("design:type", Number)
], RemoteConnectionDetails.prototype, "expiry", void 0);
__decorate([
    json2typescript_1.JsonProperty("connectionParameters", additional_data_1.AdditionalData),
    __metadata("design:type", additional_data_1.AdditionalData)
], RemoteConnectionDetails.prototype, "connectionParameters", void 0);
RemoteConnectionDetails = RemoteConnectionDetails_1 = __decorate([
    json2typescript_1.JsonObject,
    __metadata("design:paramtypes", [])
], RemoteConnectionDetails);
exports.RemoteConnectionDetails = RemoteConnectionDetails;
