"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const remote_connection_details_1 = require("./remote-connection-details");
const HEADER_USERNAME = "headerUsername";
const HEADER_PASSWORD = "headerPassword";
const REQUEST_TOPIC = "requestTopic";
const RESPONSE_TOPIC = "responseTopic";
describe('RemoteConnectionDetails', () => {
    it('should create an instance', () => {
        expect(new remote_connection_details_1.RemoteConnectionDetails()).toBeTruthy();
    });
    it('should serialise and deserialise correctly', () => {
        var rcd = new remote_connection_details_1.RemoteConnectionDetails();
        rcd.connectionType = "websocket";
        rcd.connectionUrl = "wss://hmj5ze9szf.execute-api.eu-west-1.amazonaws.com/dev";
        var json = rcd.toJson();
        console.log(json);
        var rcdResult = remote_connection_details_1.RemoteConnectionDetails.fromJson(json);
        expect(rcdResult.connectionUrl).toStrictEqual(rcd.connectionUrl);
        expect(rcdResult).toStrictEqual(rcd);
    });
});
