"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ResponseQuery_1;
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const jsonable_1 = require("./jsonable");
let ResponseQuery = ResponseQuery_1 = class ResponseQuery extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.requestId = undefined;
        this.flowName = undefined;
        this.flowType = undefined;
        this.startDate = undefined;
        this.endDate = undefined;
        this.maxResults = undefined;
    }
    static from(requestId, flowName, flowType, startDate, endDate, maxResults) {
        const responseQuery = new ResponseQuery_1();
        responseQuery.requestId = requestId;
        responseQuery.flowName = flowName;
        responseQuery.flowType = flowType;
        responseQuery.startDate = startDate;
        responseQuery.endDate = endDate;
        responseQuery.maxResults = maxResults;
        return responseQuery;
    }
};
__decorate([
    json2typescript_1.JsonProperty('requestId', String, true),
    __metadata("design:type", String)
], ResponseQuery.prototype, "requestId", void 0);
__decorate([
    json2typescript_1.JsonProperty('flowName', String, true),
    __metadata("design:type", String)
], ResponseQuery.prototype, "flowName", void 0);
__decorate([
    json2typescript_1.JsonProperty('flowType', String, true),
    __metadata("design:type", String)
], ResponseQuery.prototype, "flowType", void 0);
__decorate([
    json2typescript_1.JsonProperty('startDate', Number, true),
    __metadata("design:type", Number)
], ResponseQuery.prototype, "startDate", void 0);
__decorate([
    json2typescript_1.JsonProperty('endDate', Number, true),
    __metadata("design:type", Number)
], ResponseQuery.prototype, "endDate", void 0);
__decorate([
    json2typescript_1.JsonProperty('maxResults', Number, true),
    __metadata("design:type", Number)
], ResponseQuery.prototype, "maxResults", void 0);
ResponseQuery = ResponseQuery_1 = __decorate([
    json2typescript_1.JsonObject('ResponseQuery')
], ResponseQuery);
exports.ResponseQuery = ResponseQuery;
