"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Response_1;
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const jsonable_1 = require("./jsonable");
const request_1 = require("./request");
const additional_data_1 = require("./additional-data");
/**
 * Response to a generic {@link Request} that contains the outcome and bespoke response data for that request type.
 *
 * @tsoaModel
 */
let Response = Response_1 = class Response extends jsonable_1.Jsonable {
    constructor() {
        super(...arguments);
        this.originatingRequest = undefined;
        this.success = false;
        this.outcomeMessage = undefined;
        this.responseData = new additional_data_1.AdditionalData();
        this.flowServiceId = undefined;
        this.processedInBackground = false;
    }
    /**
       * Convert a JSON string into a {@link Response} object if possible
       *
       * @param json The JSON to convert
       */
    static fromJson(json) {
        return this.baseFromJson(json, Response_1);
    }
};
__decorate([
    json2typescript_1.JsonProperty('originatingRequest', request_1.Request, true),
    __metadata("design:type", request_1.Request)
], Response.prototype, "originatingRequest", void 0);
__decorate([
    json2typescript_1.JsonProperty('success'),
    __metadata("design:type", Boolean)
], Response.prototype, "success", void 0);
__decorate([
    json2typescript_1.JsonProperty('outcomeMessage'),
    __metadata("design:type", String)
], Response.prototype, "outcomeMessage", void 0);
__decorate([
    json2typescript_1.JsonProperty('responseData', additional_data_1.AdditionalData),
    __metadata("design:type", additional_data_1.AdditionalData)
], Response.prototype, "responseData", void 0);
__decorate([
    json2typescript_1.JsonProperty('flowServiceId', String, true),
    __metadata("design:type", String)
], Response.prototype, "flowServiceId", void 0);
__decorate([
    json2typescript_1.JsonProperty('processedInBackground'),
    __metadata("design:type", Boolean)
], Response.prototype, "processedInBackground", void 0);
Response = Response_1 = __decorate([
    json2typescript_1.JsonObject('Response')
], Response);
exports.Response = Response;
