"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
const json2typescript_1 = require("json2typescript");
const additional_data_1 = require("./additional-data");
const amounts_1 = require("./amounts");
const card_1 = require("./card");
var TransactionResponseOutcome;
(function (TransactionResponseOutcome) {
    TransactionResponseOutcome["APPROVED"] = "APPROVED";
    TransactionResponseOutcome["DECLINED"] = "DECLINED";
})(TransactionResponseOutcome = exports.TransactionResponseOutcome || (exports.TransactionResponseOutcome = {}));
/**
 * A transaction response representing the outcome of processing a {@link TransactionRequest}.
 */
let TransactionResponse = class TransactionResponse {
    constructor() {
        this.id = undefined;
        this.card = undefined;
        this.outcome = undefined;
        this.outcomeMessage = undefined;
        this.amounts = undefined;
        this.responseCode = undefined;
        this.paymentMethod = undefined;
        this.references = new additional_data_1.AdditionalData();
        this.flowServiceId = undefined;
        this.flowStage = undefined;
    }
};
__decorate([
    json2typescript_1.JsonProperty('id'),
    __metadata("design:type", String)
], TransactionResponse.prototype, "id", void 0);
__decorate([
    json2typescript_1.JsonProperty('card', card_1.Card, true),
    __metadata("design:type", card_1.Card)
], TransactionResponse.prototype, "card", void 0);
__decorate([
    json2typescript_1.JsonProperty('outcome', String),
    __metadata("design:type", String)
], TransactionResponse.prototype, "outcome", void 0);
__decorate([
    json2typescript_1.JsonProperty('outcomeMessage'),
    __metadata("design:type", String)
], TransactionResponse.prototype, "outcomeMessage", void 0);
__decorate([
    json2typescript_1.JsonProperty('amounts', amounts_1.Amounts, true),
    __metadata("design:type", amounts_1.Amounts)
], TransactionResponse.prototype, "amounts", void 0);
__decorate([
    json2typescript_1.JsonProperty('responseCode', String, true),
    __metadata("design:type", String)
], TransactionResponse.prototype, "responseCode", void 0);
__decorate([
    json2typescript_1.JsonProperty('paymentMethod'),
    __metadata("design:type", String)
], TransactionResponse.prototype, "paymentMethod", void 0);
__decorate([
    json2typescript_1.JsonProperty('references', additional_data_1.AdditionalData, true),
    __metadata("design:type", additional_data_1.AdditionalData)
], TransactionResponse.prototype, "references", void 0);
__decorate([
    json2typescript_1.JsonProperty('flowServiceId', String, true),
    __metadata("design:type", String)
], TransactionResponse.prototype, "flowServiceId", void 0);
__decorate([
    json2typescript_1.JsonProperty('flowStage', String, true),
    __metadata("design:type", String)
], TransactionResponse.prototype, "flowStage", void 0);
TransactionResponse = __decorate([
    json2typescript_1.JsonObject('TransactionResponse')
], TransactionResponse);
exports.TransactionResponse = TransactionResponse;
