/*
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
import { Customer } from '../../lib/model/customer';
import { AdditionalData } from '../../lib/model/additional-data';
import { Token } from '../../lib/model/token';

describe('Customer', () => {
  it('should create an instance', () => {
    expect(new Customer()).toBeTruthy();
  });

  it('should serialize and deserialize correctly', () => {
    const ad = new AdditionalData();
    ad.addData('cheese', 'bire');
    const token = Token.from('5353535', 'card');
    const tokens = new Array<Token>();
    tokens[0] = token;
    const customer = Customer.from('123', 'Jonny Big Cheese', ad, tokens);

    const json = customer.toJson();
    const customerResult = Customer.fromJson(json);

    expect(customerResult).toStrictEqual(customer);
  });
});
